package com.persagy.proxy.adm.model;

import com.persagy.proxy.adm.annotations.CascadeColumn;
import lombok.Data;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * ADM 竖井 实体
 * @author lvxy
 * @date 2021/8/17
 */
@Data
public class AdmShaft {

    /** 竖井id */
    private String id;
    /** 竖井名称 */
    private String name;
    /** 竖井本地编码 */
    private String localId;
    /** 竖井本地名称 */
    private String localName;
    /** BIM模型中编码 */
    private String bimId;
    /** 设计图纸中编码 */
    private String cadId;
    /** 二维码图片 */
    private String qRCodePic;
    /** 二维码内容 */
    private String defaultQRCode;
    /** 项目id */
    private String projectId;
    /** BIM模型中坐标 */
    private String bimLocation;
    /** 竖井顺序码 */
    private Integer shaftSequenceId;
    /** 功能类型 */
    private String shaftfunctype;
    /** 信息点 */
    private Map<String, Object> infos;

    /** BIM模型中轮廓坐标 */
    private List<AdmPointPosition> outline;
    /** 对象类型 */
    private String objectType = "shaft";
    /** 级联-竖井内的设备 */
    @CascadeColumn(graphCode = "MechInArch", relCode = "Eq2Sh", selectToObj = false)
    private List<AdmEquipment> equipmentList;
    /** 级联-竖井内的建筑 */
    @CascadeColumn(graphCode = "ArchForArch", relCode = "Sh2Bd")
    private List<AdmBuilding> buildingList;
    /** 级联-竖井内的系统 */
    @CascadeColumn(graphCode = "MechInArch", relCode = "Sy2Sh", selectToObj = false)
    private List<AdmSystem> systemList;
    /** 贯通关系   self = true  同样的对象查询时 id可以互相调换查询   */
    @CascadeColumn(graphCode = "ThroughRelationship", relCode = "Sh2Sh")
    private List<AdmShaft> shaftThroughList;
    /** 竖井内的业务空间  self = true  同样的对象查询时 id可以互相调换查询   */
    @CascadeColumn(graphCode = "ArchSubset", relCode = "Sh2Sp")
    private List<AdmSpace> spaceList;
    /** 统计信息 */
    private Map<String, Object> statistics;
    /** 创建时间 */
    private Date createTime;
    /** 最后更新日期 */
    private Date lastUpdate;

    /** 对象类型code */
    private String classCode;
}
